import java.util.Stack;

public abstract class SmartBot extends Bot {

    protected static final char FORWARD = '^';
    protected static final char BACKWARD = 'v';
    protected static final char LEFT = '<';
    protected static final char RIGHT = '>';
    protected static final char SHOOT = 'f';

    protected int tilesMoved;

    protected final Stack<Character> moves;


    protected SmartBot(String[] args) {
        super(args);
        this.tilesMoved = 0;
        this.moves = new Stack<>();
    }

    @Override
    protected char nextMove(View view) throws Exception {
        return 0;
    }


}
